﻿using System;
using System.Collections.Generic;
using System.Text;
using Aliyun.Acs.Core;
using Aliyun.Acs.Core.Exceptions;
using Aliyun.Acs.Core.Profile;
using Aliyun.Acs.Dyplsapi.Model.V20170525;
using System.Security.Cryptography;
using System.Threading;

namespace ConsoleApplication1
{
    class Program
    {
        //产品名称:云通信隐私保护产品,开发者无需替换
        const String product = "Dyplsapi";
        //产品域名,开发者无需替换
        const String domain = "dyplsapi.aliyuncs.com";

        // TODO 此处需要替换成开发者自己的AK(在阿里云访问控制台寻找)
        const String accessKeyId = "yourAccessKeyId";
        const String accessKeySecret = "yourAccessKeySecret";       

        public static BindAxbResponse bindAxb()
        {
            IClientProfile profile = DefaultProfile.GetProfile("cn-hangzhou", accessKeyId, accessKeySecret);
            DefaultProfile.AddEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
            IAcsClient client = new DefaultAcsClient(profile);
            BindAxbRequest request = new BindAxbRequest();
            request.PhoneNoA = "15010101010";
            request.PhoneNoB = "15020202020";
            request.Expiration = "2017-09-18 17:00:00";
            //可选:是否需要录制音频-默认是false
            request.IsRecordingEnabled = false;
            //外部业务自定义ID属性
            request.OutId = "yourOutId";
            //hint 此处可能会抛出异常，注意catch
            BindAxbResponse response = null;
            try
            {
                response = client.GetAcsResponse(request);
            }
            catch (ServerException e)
            {
            }
            catch (ClientException e)
            {
            }
            return response;
        }
        public static BindAxnResponse bindAxn()
        {
            IClientProfile profile = DefaultProfile.GetProfile("cn-hangzhou", accessKeyId, accessKeySecret);
            DefaultProfile.AddEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
            IAcsClient client = new DefaultAcsClient(profile);
            BindAxnRequest request = new BindAxnRequest();
            request.PhoneNoA = "15010101010";
            request.PhoneNoB = "15020202020";
            request.Expiration = "2017-09-18 17:00:00";
            //可选:是否需要录制音频-默认是false
            request.IsRecordingEnabled = false;
            //外部业务自定义ID属性
            request.OutId = "yourOutId";
            //AXN的隐私号码X一共支持2种号码类型 NO_95 NO_170
            request.NoType = "NO_95";

            BindAxnResponse response = null;
            try
            {
                response = client.GetAcsResponse(request);
            }
            catch (ServerException e)
            {
            }
            catch (ClientException e)
            {
            }
            return response;
        }

        public static UnbindSubscriptionResponse unbind(String subId, String secretNo)
        {
            IClientProfile profile = DefaultProfile.GetProfile("cn-hangzhou", accessKeyId, accessKeySecret);
            DefaultProfile.AddEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
            IAcsClient client = new DefaultAcsClient(profile);
            UnbindSubscriptionRequest request = new UnbindSubscriptionRequest();
            request.SubsId = subId;
            request.SecretNo = secretNo;
            UnbindSubscriptionResponse response = null;
            try
            {
                response = client.GetAcsResponse(request);
            }
            catch (ServerException e)
            {
            }
            catch (ClientException e)
            {
            }
            return response;
        }
        public static UpdateSubscriptionResponse updateSubscription()
        {
            IClientProfile profile = DefaultProfile.GetProfile("cn-hangzhou", accessKeyId, accessKeySecret);
            DefaultProfile.AddEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
            IAcsClient client = new DefaultAcsClient(profile);
            UpdateSubscriptionRequest request = new UpdateSubscriptionRequest();

            //对应的产品类型
            request.ProductType = "AXB_170";
            //必填:绑定关系ID
            request.SubsId = "123456";
            //必填:绑定关系对应的X号码
            request.PhoneNoX = "170000000";
            //必填:操作类型指令
            request.OperateType = "updateNoA";
            //可选:需要修改的A号码
            request.PhoneNoA = "150000000";
            UpdateSubscriptionResponse response = null;
            try
            {
                response = client.GetAcsResponse(request);
                if (response.Code != null && response.Code == "OK")
                {
                    //请求成功
                }
            }
            catch (ServerException e)
            {
            }
            catch (ClientException e)
            {
            }
            return response;
        }

        public static QuerySubscriptionDetailResponse querySubscriptionDetail()
        {
            IClientProfile profile = DefaultProfile.GetProfile("cn-hangzhou", accessKeyId, accessKeySecret);
            DefaultProfile.AddEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
            IAcsClient client = new DefaultAcsClient(profile);
            QuerySubscriptionDetailRequest request = new QuerySubscriptionDetailRequest();

            //对应的产品类型
            request.ProductType = "AXB_170";
            //必填:绑定关系ID
            request.SubsId = "123456";
            //必填:绑定关系对应的X号码
            request.PhoneNoX = "170000000";
            QuerySubscriptionDetailResponse response = null;
            try
            {
                response = client.GetAcsResponse(request);
                if (response.Code != null && response.Code == "OK")
                {
                    //请求成功
                }
            }
            catch (ServerException e)
            {
            }
            catch (ClientException e)
            {
            }
            return response;
        }

        public static QueryRecordFileDownloadUrlResponse queryRecordFileDownloadUrl(String callId, String CallTime)
        {
            IClientProfile profile = DefaultProfile.GetProfile("cn-hangzhou", accessKeyId, accessKeySecret);
            DefaultProfile.AddEndpoint("cn-hangzhou", "cn-hangzhou", product, domain);
            IAcsClient client = new DefaultAcsClient(profile);
            QueryRecordFileDownloadUrlRequest request = new QueryRecordFileDownloadUrlRequest();

            //对应的产品类型
            request.ProductType = "AXB_170";
            //话单回执中返回的标识每一通唯一通话行为的callId           
            request.CallId = callId;
            //话单回执中返回的callTime字段
            request.CallTime = "callTime";
            QueryRecordFileDownloadUrlResponse response = null;
            try
            {
                response = client.GetAcsResponse(request);
                if (response.Code != null && response.Code == "OK")
                {
                    //请求成功
                }
            }
            catch (ServerException e)
            {
            }
            catch (ClientException e)
            {
            }
            return response;
        }


        static void Main(string[] args)
        {

            //AXB绑定
            BindAxbResponse axbResponse = bindAxb();
            Console.Write("AXB绑定接口返回的结果----------------");
            Console.Write("Code=" + axbResponse.Code);
            Console.Write("Message=" + axbResponse.Message);
            Console.Write("RequestId=" + axbResponse.RequestId);
            String axbSubsId = axbResponse.SecretBindDTO == null ? null : axbResponse.SecretBindDTO.SubsId;
            String axbSecretNo = axbResponse.SecretBindDTO == null ? null : axbResponse.SecretBindDTO.SecretNo;
            Console.Write("subsId=" + axbSubsId);
            Console.Write("secretNo=" + axbSecretNo);
            Console.WriteLine();

            //预留一分钟给您进行拨测
            Thread.Sleep(60000);

            if (axbResponse.Code != null && axbResponse.Code == "OK")
            {
                UnbindSubscriptionResponse unbindResponse = unbind(axbSubsId, axbSecretNo);
                Console.Write("解绑接口返回数据AXB----------------");
                Console.Write("Code=" + unbindResponse.Code);
                Console.Write("Message=" + unbindResponse.Message);
                Console.Write("RequestId=" + unbindResponse.RequestId);
                Console.WriteLine();
            }
            
            Thread.Sleep(3000);

            //AXN绑定
            BindAxnResponse axnResponse = bindAxn();
            Console.Write("AXN绑定接口返回的结果----------------");
            Console.Write("Code=" + axnResponse.Code);
            Console.Write("Message=" + axnResponse.Message);
            Console.Write("RequestId=" + axnResponse.RequestId);
            String axnSubsId = axnResponse.SecretBindDTO == null ? null : axnResponse.SecretBindDTO.SubsId;
            String axnSecretNo = axnResponse.SecretBindDTO == null ? null : axnResponse.SecretBindDTO.SecretNo;
            Console.Write("subsId=" + axnSubsId);
            Console.Write("secretNo=" + axnSecretNo);
            Console.WriteLine();

            //预留一分钟给您进行拨测 
            Thread.Sleep(60000);

            if (axnResponse.Code != null && axnResponse.Code == "OK")
            {
                UnbindSubscriptionResponse unbindResponse = unbind(axnSubsId, axnSecretNo);
                Console.Write("解绑接口返回数据AXN----------------");
                Console.Write("Code=" + unbindResponse.Code);
                Console.Write("Message=" + unbindResponse.Message);
                Console.Write("RequestId=" + unbindResponse.RequestId);
                Console.WriteLine();
            }                     

        }

    }
}
